#include <36064s.h>
#include "sci3.h"
#include "memmap.h"
#include "sciflash.h"
#include "vs-bb020.h"

extern double *Gainmap;
volatile unsigned char memmap[MEMMAP_SIZE];
volatile BYTE scicombuff[30];
volatile BYTE scireadcnt;
extern const BYTE strHex[16];


void ClearBuff(){
	scireadcnt = 0;
}

void SendPcErr()
{
	const unsigned char err[6]={"ERROR"};
	unsigned char i;
	
	for(i=0;i<6 && err[i]!='\0';i++)
		SciByteTx(err[i]);
}

unsigned char CH_Rv_NUM(unsigned char a)
{
	if(a>='0' && a<='9'){
		return 0;
	}
	else if(a>='A' && a<='F'){
		return 0;
	}
	else if(a>='a' && a<='f'){
		return 0;
	}
	return 1;
}

unsigned char AtoH(unsigned char *str)
{
	unsigned char data;
	if(str[1]>='0' && str[1]<='9')
		data=str[1]-'0';
	else if(str[1]>='a' && str[1]<='f')
		data=str[1]-'a'+10;
	else if(str[1]>='A' && str[1]<='F')
		data=str[1]-'A'+10;
	
	if(str[0]>='0' && str[0]<='9')
		data+=(str[0]-'0')<<4;
	else if(str[0]>='a' && str[0]<='f')
		data+=(str[0]-'a'+10)<<4;
	else if(str[0]>='A' && str[0]<='F')
		data+=(str[0]-'A'+10)<<4;
	
	return data;
}


unsigned long AtoH2inv(unsigned char *str,unsigned char size)
{
	unsigned long data;
	unsigned char i;
	data=0;
	
	for(i=0;i<size;i++){
		if(str[i]>='0' && str[i]<='9')
			data+=(unsigned long)(str[i]-'0')<<4*(size-i-1);
		else if(str[i]>='a' && str[0]<='f')
			data+=(unsigned long)(str[i]-'a'+10)<<4*(size-i-1);
		else if(str[i]>='A' && str[0]<='F')
			data+=(unsigned long)(str[i]-'A'+10)<<4*(size-i-1);
	}
	return data;
}


void HtoA(unsigned char *str,unsigned char hexdata)
{
	str[0]=strHex[(hexdata & 0xf0)>>4];
	str[1]=strHex[hexdata & 0x0f];
	str[2]='\0';
}


void EditMap()
{
	unsigned char ststemp,data,sizeA,sizeD,strA[10],strD[10],errflg,temp[2];
	
	unsigned int a2;
	unsigned char a1,str[4];
	unsigned long addr,i,Dnum;
	
	errflg=0;
	switch(scicombuff[0]){
		case 'w':
		case 'W':
			
			for(sizeA=0;scicombuff[2+sizeA]!=' ';sizeA++)
			{
				strA[sizeA]=scicombuff[2+sizeA];
				if(CH_Rv_NUM(strA[sizeA])){
					errflg=1;
					break;
				}
			}
			
			if(sizeA==0){
				errflg=1;
				break;
			}
			addr=AtoH2inv(strA,sizeA);
			
			for(i=0;scicombuff[3+sizeA+i*2]!=0x0D && errflg==0; i++)
			{
				strD[0]=scicombuff[3+sizeA+i*2];
				strD[1]=scicombuff[3+sizeA+i*2+1];
			
				if(CH_Rv_NUM(strD[0]) || CH_Rv_NUM(strD[1])){
					errflg=1;
					break;
				}
						
				data=AtoH2inv(strD,2);
			
				if(addr<MEMMAP_SIZE){
					memmap[addr]=data;
				}
				else{
					errflg=1;
				}
				addr++;
			}
	
				
		break;
		
		case 'f':
		case 'F':
			switch(scicombuff[2])
			{
				case 'm':
				case 'M':
					memmap[GAIN_VERSION] = VERSION;
					Wr_MEMMAP();
				break;
			}	
		break;
		
		
		case 'r':
		case 'R':
			for(sizeA=0;scicombuff[2+sizeA]!=' ';sizeA++){
				strA[sizeA]=scicombuff[2+sizeA];
				if(CH_Rv_NUM(strA[sizeA])){
					errflg++;
					break;
				}
			}
		
			for(sizeD=0;scicombuff[3+sizeA+sizeD]!=0x0D && errflg==0; sizeD++)
			{
				strD[sizeD]=scicombuff[3+sizeA+sizeD];
				if(CH_Rv_NUM(strD[sizeD]))
				{
					errflg++;
					break;
				}
			}
			
			if(sizeA!=0 && errflg==0)
			{
				addr=AtoH2inv(strA,sizeA);
				Dnum=AtoH2inv(strD,sizeD);
				
				for(i=0;i<Dnum && errflg==0;i++)
				{
					if((addr)<MEMMAP_SIZE && sizeA!=0)
					{
							HtoA(str,memmap[addr]);
							SciByteTx(str[0]);
							SciByteTx(str[1]);
					}
					else 
						errflg++;
					addr++;
				}
			}
			else
				errflg++;
			
		break;
		default:
			errflg=1;
		break;
	}
	if(errflg!=0)
		SendPcErr();
	
}


void CheckSci()
{
	unsigned char data,i,str[10]; 	
	if(SciByteRx(&data)){
//		LED(1);
	switch(data){
	case 0x0D:	//ENTER
			scicombuff[scireadcnt]=data;
			SciByteTx(0x0D);
			if(scireadcnt!=0){
				EditMap();
				SciByteTx(0x0D);
				SciByteTx('>');
			}
			else if(scireadcnt==0){
				SciByteTx('>');
			}
			scireadcnt = 0;
			break;
	
	case 0x0a:
			
		break;
		case 'g': //z
		case 'l': //z
		case 'm': //z
		case 'o': //z
		send_data(data);
		break;
		
		default:
			scicombuff[scireadcnt]=data;
			SciByteTx(scicombuff[scireadcnt]);
			scireadcnt++;
			break;
		}
	}
}
