#include <36064s.h>
#include "sciflash.h"
#include "memmap.h"
#include <machine.h>

unsigned char Cat_Cnt;
void copyfzram ( void );
extern void LED(char i);
extern unsigned char memmap[MEMMAP_SIZE];

extern int writememmap();
extern int elaseBlock(unsigned char num);
const char hex[16] = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
extern const unsigned char map[32];


void copyfzram ( void )
{
    char  *X_BGN;
    char  *X_END;
    char  *Y_BGN;

    X_BGN = __sectop("FZTAT");                              /* Flash , Ram Address Copy*/
    X_END = __sectop("P");
    Y_BGN = __sectop("RAM");
	X_END -=1;

    memcpy(Y_BGN,X_BGN,X_END-X_BGN);                        /* Flash -> RAM Copy*/
}
void Wr_MEMMAP()
{
	unsigned char temp;
	set_imask_ccr(1);
	WDT.TMWD.BYTE   = 0xFF;                                          /* phi/8192                         */
	WDT.TCSRWD.BYTE  = 0x50;                                         /* WDT STOP,TCW ENABLE              */
	copyfzram();
	writememmap();
	set_imask_ccr(0);
	
	WDT.TCSRWD.BYTE  = 0x56;
}

void Reset(){
	WDT.TMWD.BYTE   = 0xFF;                                          /* phi/8192                         */
	WDT.TCSRWD.BYTE  = 0x50;                                          /* WDT STOP,TCW ENABLE              */
    WDT.TCWD    = 0xFF;                                          /* INITIZLIZED WDT COUNT            */
    WDT.TCSRWD.BYTE  = 0x56;   
    while(1);
}
void Rd_MEMMAP()
{
	unsigned char size;
	for(size = 0;size<MEMMAP_SIZE;size++){
		memmap[size] = map[size];
	}
}




