/************************************************************/
/*                                                          */
/*  H8/300HN Series -H8/3664-                               */
/*  Flash Memory Write/Erase Application Note               */
/*                                                          */
/*  Communication Interface                                 */
/*  : Asynchronous Serial Interface                         */
/*  Function                                                */
/*  : Slave Flash Memory Write/Erase Control Program        */
/*                                                          */
/*  External Clock : 16MHz                                  */
/*  Internal Clock : 16MHz                                  */
/*  Sub Clock      : 32.768kHz                              */
/*                                                          */
/************************************************************/
#pragma section FZTAT
#define CPUCLK  14745600		/* 20.000[MHz] */

#include <36064S.h>      /*  3694s.h Ver 2.1 ꕔC */
#include <machine.h>    /* set_imask_ccr() */
#include "memmap.h"

extern unsigned char memmap[MEMMAP_SIZE];
typedef unsigned char  BYTE;
typedef unsigned short WORD;
typedef unsigned long  DWORD;

#define N 1000

/*-------------------------------------------------
RAM [NGAϐ
-------------------------------------------------*/

#define BLK_DWORD (128 / 4)

static int n;

static BYTE WriteBuf[128];	/* ݃f[^GA */
	static BYTE TuikaBuf[128];	/* ǉ݃GA */
	static BYTE SaikaBuf[128];	/* ā@݃GA */

/************************************************************/


int elaseBlock(unsigned char num);
int writememmap();
void SetBuf(unsigned char *dst);




/*-------------------------------------------------
[v񐔂̃EFCgiCC֐FړWJj
[uS]Pʂւ̕ϊ}N
-------------------------------------------------*/
void wait_us(WORD no)
{
	no*=10;
	while(no>0){
		no--;
	}
}

/*-------------------------------------------------
memcpy}N֐
tbVɃCg PrbgNA܂ RTS
gpłȂ߁BCCWJs\B
-------------------------------------------------*/
void _memcpy(BYTE *dst, BYTE *src,BYTE cnt)        
{                                                        
	int i;
	for (i = 0; i < cnt; i++)
		dst[i] = src[i];
}                                    

/*-------------------------------------------------
memsetp
-------------------------------------------------*/
void _memset(BYTE *dst, BYTE c, WORD no)
{
	do { *dst++ = c; } while (--no);
}

/*-------------------------------------------------
݃pX֐
-------------------------------------------------*/
static void write_pulse()
{
	WORD tsp;
	int i;

	WDT.TCSRWD.BYTE = 0x5a;         /* TCWD and TCSRWD Write Enable */
	WDT.TMWD  .BYTE = 0x0b;         /* PreScaler 1/512 (34.7us @14.7456M) */
	WDT.TCWD        = 256 - 190;    /* 190 * 34.7u ~= 6.6ms */
	WDT.TCSRWD.BYTE = 0xf4;         /* WatchDog Timer ON */

	FLASH.FLMCR1.BIT.PSU = 1;       /* FLMCR1PSU-bit */
	for(i=0;i<500;i++);                    /* wait(tspsu) min=50us, typ=50us */

	if (n < 7) tsp = 30;  			/* tsp30  min= 28, typ= 30, max= 32us */
	else       tsp = 200; 			/* tsp200 min=198, typ=200, max=202us */
	
	
	FLASH.FLMCR1.BIT.P = 1;         /* FLMCR1P-bit */
	for(i=0;i< (tsp*10);i++);                    /* wait(tsp) ۸ѥٽ */
	FLASH.FLMCR1.BIT.P = 0;         /* FLMCR1P-bitر */
	wait_us(5);                     /* wait(tcp) min=5us, typ=5us */
	FLASH.FLMCR1.BIT.PSU = 0;       /* FLMCR1PSU-bitر */
	wait_us(5);                     /* wait(tcpsu) min=5us, typ=5us */
	WDT.TCSRWD.BYTE = 0x5a;         /* TCWD and TCSRWD Write Enable */
	WDT.TCWD        = 0;            /* (256 - 0) * 32u = 8.192ms */
	WDT.TCSRWD.BYTE = 0xf0;         /* WatchDog Timer OFF */
}

/*=================================================
128 oCg݁in[hEFA}jAS 7-10j
@Fdest:ݐAhX
=================================================*/
static int block_write(volatile BYTE *dest)
{
	int i,j, m, ret;
	DWORD *writep, *saikap, *tuikap, v_data;
	volatile DWORD *destp;
	char hex3[16] = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
		
	FLASH.FENR.BYTE = 0x80;                 /* FLMCR1  */
	_memset(TuikaBuf, 0xff, 128);      /* ǉݴر 0xff Ŗ߂ */

	FLASH.FLMCR1.BIT.SWE = 1;               /* SWE ޯ <- 1 */
	wait_us(1);         
	
                 /* 1us ҋ@ */
	                                   /* 128bytȅްްر */
	_memcpy(SaikaBuf, WriteBuf,128);  /* ďްرɊi[ */
	n = 1;                                  /* n = 1 */
	do {
	    m = 0;                              /* m = 0 */
	    _memcpy(dest, SaikaBuf,128);  /* ďݴرްׯ؂ɘAײ */
	    write_pulse();               /* ٽ */
	    FLASH.FLMCR1.BIT.PV = 1;            /* PVޯ <- 1 */
	    wait_us(4);                         /* 4us ҋ@ */
	    destp  = (DWORD *)dest;
	    writep = (DWORD *)WriteBuf;
	    saikap = (DWORD *)SaikaBuf;
	    tuikap = (DWORD *)TuikaBuf;
	    for (i = 0; i < 32; i++) {
	        *destp = 0xffffffff;            /* ̧ڽ H'FFаײ */
	        for(j=0;j<20;j++);                    /* 2us ҋ@ */
	        v_data = *destp;                /* ̧ް DWORDPʂذ */
	        if (v_data != *writep) m = 1;   /* ް != ̧ްȂ m=1 */
	        if (n <= 6) {                   /* n <= 6 ? */
	            *tuikap = *saikap | v_data; /* ǉްZǉްرɓ] */
	        }
	        *saikap = ~(v_data & ~*writep); /* ďްZďްرɓ] */
	        destp++ ;
			writep++;
			saikap++;
			tuikap++;
	    }	                                /* 128byte ް̧? */
		
	    FLASH.FLMCR1.BIT.PV = 0;            /* PVޯĂر */
	    wait_us(2);                         /* 2us ҋ@ */
	    if (n <= 6) {                       /* n <= 6 ? */
	        _memcpy(dest, TuikaBuf,128); /* ǉްرׯ؂ɘAײ */
	        write_pulse();            		/* Write Pulseǉ */
	    }
	    if (m == 0) { ret =  0;  break; }   /* ݏI (m = 0) */
	    if (n >= N) { ret = -1;  break; }   /* ݕs */
	    n++;
	} while (1);
	
	FLASH.FLMCR1.BIT.SWE = 0;               /* FLMCR1SWEbitر */
	wait_us(100);                           /* wait(tcwse) min=100us, typ=100us */
	FLASH.FENR.BYTE = 0x00;                 /* FLMCR1 ֎~ */
	return ret;
}

//=================================================
//
//=================================================
 int block_ers(BYTE block_num)
{
	int i, m, ret;
	DWORD v_data;
	volatile DWORD *destp;

	m = 0;
	FLASH.FENR.BYTE = 0x80;                 //* FLMCR1  
	FLASH.FLMCR1.BIT.SWE = 1;               //* SWE ޯ <- 1 
	wait_us(1);                             //* 1us ҋ@ 
	
	do {
	    n = 1;                              //* m = 0 
	    FLASH.EBR1.BYTE = 1<<block_num;            //* EBR1.BIT<-set 

ERS_STA:		
		WDT.TCSRWD.BYTE = 0x5a;         //* TCWD and TCSRWD Write Enable 
		WDT.TMWD  .BYTE = 0x0D;         //* PreScaler 1/2048 (129.8us @14.7456M) 
		WDT.TCWD        = 256 - 151;    //* 151 * 129.8u ~=19.6ms 
		WDT.TCSRWD.BYTE = 0xf4;         //* WatchDog Timer ON 
		
	    
		FLASH.FLMCR1.BIT.ESU = 1;
	    
		wait_us(100);                         // 4us ҋ@ 
		
		FLASH.FLMCR1.BIT.E = 1;
		
		wait_us(10000);
		
		FLASH.FLMCR1.BIT.E = 0;
		
		wait_us(10);  
		
		FLASH.FLMCR1.BIT.ESU = 0;
		
		wait_us(10);  
		
		WDT.TCSRWD.BYTE = 0xf0;         /* WatchDog Timer OFF */
		
		FLASH.FLMCR1.BIT.EV = 1;
		
		wait_us(20);
		
		destp = (DWORD *)(0x400*block_num);
		 
		while(destp < (DWORD *)((0x400*block_num)+0x400)){
			*destp = 0xffffffff;
			for(i=0;i<20;i++);                    // 2us ҋ@ 
			v_data = *destp;                // ̧ް DWORDPʂذ 
			if(~v_data != 0){
				 m = 1;
				 break;
			}
			else{
				destp++;
			}
		}
		
		FLASH.FLMCR1.BIT.EV = 0;
		wait_us(4);
		
		if(m == 0){ ret = 0;  break; } 
		if (n >= N) { ret = -1;  break; } 
		n++;
	} while (1);


	FLASH.FLMCR1.BIT.SWE = 0;              // / FLMCR1SWEbitر 
	wait_us(100);                         //  / wait(tcwse) min=100us, typ=100us 
	FLASH.FENR.BYTE = 0x00;               //  / FLMCR1 ֎~ 
	return ret;
}

int writememmap(){
	
	int temp;	
	elaseBlock(1);
	wait_us(1000);
	_memcpy(WriteBuf,memmap,MEMMAP_SIZE);
	FLASH.FENR.BIT.FLSHE = 1;
	temp = block_write((unsigned char *)0x400);
	FLASH.FENR.BIT.FLSHE = 0;
}

int elaseBlock(unsigned char num){
	int temp;
	FLASH.FENR.BIT.FLSHE = 1;
	temp = block_ers(num);
	FLASH.FENR.BIT.FLSHE = 0;
	return temp;
}
#pragma section
